﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class MainScript : MonoBehaviour
{
    public GameObject houseModel;
    public Material cutMaterial;

    public Shader coneCutoutShader;
    public Slider slider;


    private float speed = 5;
    private float rotateSpeed = 1;

    private float rotX;
    private float rotY;

    private float moveFB;
    private float moveLR;

    public GameObject player;

    /**
     Start is called before the first frame update
     */
    void Start()
    {
        Cursor.visible = false;
        Shader.SetGlobalVector("_MyBoxWorldPos", new Vector4(3.39f, -61.63f, -34.26f, 1f));
        slider = GameObject.Find("Slider").GetComponent<Slider>();
        Shader.SetGlobalFloat("_MyConeAngle", slider.value);
        slider.enabled = false;

        for (int i = 0; i < houseModel.transform.childCount; i++)
        {
            GameObject houseObj = houseModel.transform.GetChild(i).gameObject;
            MeshRenderer objRenderer = houseObj.GetComponent<MeshRenderer>();
            if (objRenderer == null) continue;

            Material[] originalMaterials = new Material[objRenderer.materials.Length];
            Material[] cutoutMaterials = new Material[objRenderer.materials.Length];
            for (int j = 0; j < objRenderer.materials.Length; j++)
            {
                // set coneCutoutShader for every material
                objRenderer.materials[j].shader = coneCutoutShader;
            }
        }
    }

    /**
     Update is called once per frame
     */
    void Update()
    {
        if (Input.GetKey(KeyCode.LeftControl))
        {
            Cursor.visible = true;
            slider.enabled = true;
            Shader.SetGlobalFloat("_MyConeAngle", GameObject.Find("Slider").GetComponent<Slider>().value);

        }
        else
        {
            slider.enabled = false;
            Cursor.visible = false;

            moveFB = Input.GetAxis("Vertical") * speed;
            moveLR = Input.GetAxis("Horizontal") * speed;

            // rotate view
            rotX = Input.GetAxis("Mouse X") * rotateSpeed;
            rotY = Input.GetAxis("Mouse Y") * rotateSpeed;

            Vector3 movement = new Vector3(moveFB, 0, -moveLR);

            transform.Rotate(-rotY, 0, 0);

            player.transform.Rotate(0, rotX, 0);
            player.transform.Translate(movement * Time.deltaTime);
        }



        if (Input.GetKey("q"))
        {
            player.transform.Translate(new Vector3(0, 5, 0) * Time.deltaTime);
        }
        if (Input.GetKey("y"))
        {
            player.transform.Translate(new Vector3(0, -5, 0) * Time.deltaTime);
        }

    }
}
